using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices; //     PInvoke

namespace TestWUSB
{
    public partial class Form1 : Form
    {
        //**********     Dll *********
        [DllImport("WUSBdrv")]
        public static extern Int32 WUSB_Open();

        [DllImport("WUSBdrv")]
        public static extern Int32 WUSB_SetupPortA(Byte iomsk);

        [DllImport("WUSBdrv")]
        public static extern Int32 WUSB_WritePortA(Byte value);

        [DllImport("WUSBdrv")]
        public static extern Int32 WUSB_ReadPortA(ref Byte data);        
        //*********************************************************
        

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            Int32 status = WUSB_Open();
            if (status == 0)
            {
                MessageBox.Show("ERROR! Can`t open WodmanUSB device", "Info",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            else
            {
                MessageBox.Show("Open OK", "Info",
                    MessageBoxButtons.OK, MessageBoxIcon.Information);
            }    
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string s;
            s = textBox1.Text;
            Byte mask = Byte.Parse(s);
            Int32 status = WUSB_SetupPortA(mask);
            if (status == 0)
            {
                MessageBox.Show("ERROR! Can`t set Mask", "Info",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            else
            {
                MessageBox.Show("IOMask was sucsesfully set", "Info",
                    MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string s;
            s = textBox2.Text;
            Byte data = Byte.Parse(s);
            Int32 status = WUSB_WritePortA(data);
            if (status == 0)
            {
                MessageBox.Show("Write Error!", "Info",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Byte data = 0;
            Int32 status = WUSB_ReadPortA(ref data);
            if (status == 0)
            {
                MessageBox.Show("Read Error!", "Info",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            string s;
            s = data.ToString();
            textBox3.Text = s;
        }
    }
}